from sklearn.feature_extraction.text import CountVectorizer, TfidfVectorizer
from sklearn.naive_bayes import  MultinomialNB
from sklearn.model_selection import train_test_split
import pandas as pd

if __name__ == "__main__":

    #trening skup
    corpus = [
        'Chinese Beijing Chinese',
        'Chinese Chinese Shanghai',
        'Chinese Macao',
        'Tokyo Japan Chinese'
    ]

    classes= ['yes', 'yes', 'yes', 'no']

    #pravljenje term-matrice sa brojem pojavljivanja reci
    vectorizer = CountVectorizer()
    x_train = vectorizer.fit_transform(corpus)

    """
    #pravljenje term-matrice sa tf-idf merom
    tdidf_vectorizer=TfidfVectorizer(norm='l1')
    x_train=tdidf_vectorizer.fit_transform(corpus)
    """

    print('Trening skup')
    print('Atributi - termi')
    print(vectorizer.get_feature_names())
    print()
    print('Instance & term-matrica')
    print(pd.DataFrame(x_train.toarray(), index= corpus, columns=vectorizer.get_feature_names()))
    print()

    #pravljenje modela primenom algoritma Multinomojalni naivni Bajes na trening skup
    clf_mnb = MultinomialNB()
    clf_mnb.fit(x_train, classes)

    print('Broj instanci po klasama')
    print(pd.Series(clf_mnb.class_count_, index=clf_mnb.classes_))
    print()
    print('Broj pojavljivanja reci po klasama')
    print(pd.DataFrame(clf_mnb.feature_count_, index=clf_mnb.classes_, columns=vectorizer.get_feature_names()))
    print()

    #transformisanje test instance u term-matricu
    x_test_text = ['Chinese Chinese Chinese Tokyo Japan']
    x_test = vectorizer.transform(x_test_text)

    #klasifikacija test instance
    y_pred = clf_mnb.predict(x_test)
    print('Dodeljena klasa', y_pred)
