import pandas as pd
from sklearn.naive_bayes import  GaussianNB
from sklearn.model_selection import train_test_split
import sklearn.metrics as met
from termcolor import colored

if __name__ == "__main__":
    #ucitavanje skupa
    df = pd.read_csv("iris.csv")

    featurs = df.columns[:4].tolist()
    x=df[featurs]
    y=df["Species"]

    #podela skupa na trening i test skup
    x_train, x_test, y_train, y_test = train_test_split(x, y, test_size=0.3, stratify=y)

    print(colored("GaussianNB", "blue"))
    """
    GaussianNB
    parametar:
        priors : zadate verovatnoce klasa
    """

    #primena algoritma Naivni Bajes za neprekidne atribute
    clf_gnb = GaussianNB()
    clf_gnb.fit(x_train, y_train)

    #klasifikacija test instanci
    y_pred = clf_gnb.predict(x_test)

    #ispis rezultata klasifikacije na test instancama
    cnf_matrix = met.confusion_matrix(y_test, y_pred)
    print("Matrica konfuzije", cnf_matrix, sep="\n")
    print("\n")

    accuracy = met.accuracy_score(y_test, y_pred)
    print("Preciznost", accuracy)
    print("\n")

    class_report = met.classification_report(y_test, y_pred, target_names=df["Species"].unique())
    print("Izvestaj klasifikacije", class_report, sep="\n")



